<template>
  <div id="home">
    <main>
      <section class="logReg">
        <b-container>
          <b-col col md="6" class="forms-centered">
            <span class="title">Регистрация</span>
              <form class="logRegBox" @submit.prevent="registerUser">
                  <div class="form-group">
                    <label for="name" >
                      Имя пользователя
                      <span style="color:red">*</span>
                    </label>
                    <input v-model="username" type="text" class="form-control" id="name" />
                    <div v-if="name_required" style="color:red">{{name_value}}</div>
                  </div>
                  <div class="form-group">
                    <label for="mail">
                      Эл. адрес
                    </label>
                    <input v-model="email" type="email" class="form-control" id="mail" />
                    <div v-if="email_required" style="color:red">{{email_value}}</div>
                  </div>
                  <div class="form-group">
                    <label for="password">
                      Пароль
                      <span style="color:red">*</span>
                    </label>
                    <input v-model="password" type="password" class="form-control" id="password" />
                    <div v-if="pass_required" style="color:red">{{pass_value}}</div>
                  </div>
                  <div class="form-group">
                    <input @click.prevent="registerUser" type="submit" class="submit-button btn-4 w-100" value="Регистрация" />
                  </div>
                   <div v-if="nan_field_errors" style="color:red">{{error}}</div>
                  <div class="form-group sign-in-up">
                    <span @click.prevent="userLogin"><a href="javascript.void(0)"> Авторизоваться </a> </span>
                  </div>
              </form>
            </b-col>
         </b-container>
      </section>
    </main>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from "vuex";
import { Token } from "../router/Auth";

export default {
  data() {
    return {
      username: "",
      password: "",
      email: "",

      name_value: "",
      pass_value: "",
      email_value: "",
      error: "",

      name_required: false,
      pass_required: false,
      email_required: false,
      nan_field_errors: false
    };
  },
  components: {
    
  },
  methods: {
    ...mapActions(["Register"]),

    registerUser() {
      let data = {
        username: this.username,
        email: this.email,
        password: this.password,
      };
      this.Register(data)
      .then(res => {
        if(res){
          this.$router.push("/");
        }
      })
      .catch(err => {

            if(err.response.data.username == "Это поле не может быть пустым."){
              this.name_required = true;
              this.name_value = "Это поле не может быть пустым."
            }
            if(err.response.data.password == "Это поле не может быть пустым."){
              this.pass_required = true;
              this.pass_value = "Это поле не может быть пустым."
            }
            if(err.response.data.email){
              this.email_required = true;
              this.email_value = "Введите корректный адрес электронной почты."
            }
            if(err.response.data.non_field_errors){
              this.nan_field_errors = true;
              this.error = "Невозможно войти с предоставленными учетными данными."
            }
           console.log(err)
      });
    },

    userLogin(){
      this.$router.push('/login')
    },
  },
  created() {
    if (Token.get.token()) {
      this.$router.push("/");
    }
  },
};
</script>
